SET NOCOUNT ON;
go
USE ImEx;
go
IF EXISTS
 (SELECT *
  FROM   sys.objects
  WHERE  object_id = OBJECT_ID(N'dbo.PerfTest')
  AND    type IN (N'P', N'PC'))
BEGIN;
  DROP PROCEDURE dbo.PerfTest;
END;
go

-- Wrapper procedure to test a bin-packing procedure
CREATE PROCEDURE dbo.PerfTest
                 @TheProc varchar(20)
AS
-- Schema-qualify the procedure name
DECLARE @QualifiedProcname varchar(24);
SET @QualifiedProcname = 'dbo.' + @TheProc;

-- Clear results from previous tests (if any)
UPDATE dbo.Registrations SET SessionNo = NULL;
TRUNCATE TABLE dbo.Sessions;

-- Force empty cache
CHECKPOINT;
DBCC FREEPROCCACHE WITH NO_INFOMSGS;
DBCC DROPCLEANBUFFERS WITH NO_INFOMSGS;

-- Execute procedure, keep track of execution time
DECLARE @Start datetime, @End datetime;
SET @Start = CURRENT_TIMESTAMP;

EXEC @QualifiedProcname @MaxCandidatesPerSession = 100;

SET @End = CURRENT_TIMESTAMP;

-- Return measured execution time to caller
SELECT   @TheProc AS "Procedure",
         DATEDIFF(ms, @Start, @End) AS Elapsed;
go
