SET NOCOUNT ON;
go
USE ImEx;
go

-- Run procedure to test. The PerfTest proc will return execution time
EXEC dbo.PerfTest @TheProc = 'OrderAsc';

-- Show results, for efficiency comparison
WITH PerYearQuarter AS
 (SELECT   Year, Quarter,
           COUNT(*) AS NumSessions,
           SUM(SpaceLeft) AS SeatsEmpty
  FROM     dbo.Sessions
  GROUP BY Year, Quarter)
SELECT     COALESCE (CAST(Quarter AS varchar(3)), 'ALL') AS Quarter,
           SUM(NumSessions) AS NumSessions,
           SUM(NumSessions * 100.0 - SeatsEmpty) / SUM(NumSessions) AS AvgSessionSize,
           AVG(SeatsEmpty * 1.0) AS AvgEmptySeats
FROM       PerYearQuarter
GROUP BY   Quarter WITH ROLLUP
ORDER BY   GROUPING(Quarter), Quarter;
